%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Hw8: Image segmentation by clustering          %
%    Student: Bo Han                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear
%read in the image filelist
D=dir('*.jpg');
for k=1:length(D)
imgname=D(k).name;
%for each image, we segmented it by different number of clusters
for num_cluster=2:6
str=sprintf('%2d', num_cluster);
figure;
%show original image
subplot(1,2,1);
img=imread(imgname);
imshow(img);
title(imgname);
len=size(img,1);
wid=size(img,2);

%represent each image with a vector in 3 color planes
imgmatrix=double(reshape(img,len*wid,3));

%normalize data
[meanv,stdv,data]=normalize(imgmatrix,[],[]);
%segmentation by kmeans clustering algorithm
[distance,label,tse] = kmeans1(data,num_cluster);
newmatrix=zeros(len*wid,3);
%replace each pixel value with the cluster average values
for i=1:num_cluster
    index=find(label==i);
    meanc=mean(imgmatrix(index,:));
    newmatrix(index,1)=meanc(1);
    newmatrix(index,2)=meanc(2);
    newmatrix(index,3)=meanc(3);
end
newimg=reshape(newmatrix,len,wid,3);
newimg=newimg/256;
%show segmented image
subplot(1,2,2);
imshow(newimg);
title(['segmented by ' str ' clusters']);
end
end